/*
 *
 * $Source: /filesv/usr/local/proj/sphinx/spx2/src/lib/crypto/RCS/write_pubkey.c,v $
 *
 *
 *  MODULE NAME:    write_pubkey.c
 *
 *
 *  AUTHORS:
 *
 *	J. Tardo
 *
 */


/*
 * COPYRIGHT (C) 1992 DIGITAL EQUIPMENT CORPORATION
 * ALL RIGHTS RESERVED
 *
 * "Digital Equipment Corporation authorizes the reproduction,
 * distribution and modification of this software subject to the following
 * restrictions:
 * 
 * 1.  Any partial or whole copy of this software, or any modification
 * thereof, must include this copyright notice in its entirety.
 *
 * 2.  This software is supplied "as is" with no warranty of any kind,
 * expressed or implied, for any purpose, including any warranty of fitness 
 * or merchantibility.  DIGITAL assumes no responsibility for the use or
 * reliability of this software, nor promises to provide any form of 
 * support for it on any basis.
 *
 * 3.  Distribution of this software is authorized only if no profit or
 * remuneration of any kind is received in exchange for such distribution. 
 * 
 * 4.  This software and all application programs are to be used only for
 * non-commercial purposes. However, media costs associated with the
 * distribution of the software or application programs may be recovered.
 *
 */


#include <stdio.h>
#include <ctype.h>
#include "BigZ.h"
#include "BigRSA.h"

write_pubkey(keys,name,subject,uidBuf,uid_len)
RSAKeyStorage *keys;
int  uid_len;
char *uidBuf, *name, *subject;
{
        char publicBuf [80], *tempbuf;
        FILE *publ;
        
        strcpy(publicBuf,name);
        strcat(publicBuf,"_pubkey");
        
        if ((publ = fopen(publicBuf, "w")) == NULL)
        {
            printf("\n%s: could not open/create %s", __FILE__, publicBuf);
            return(0);
        }
        fprintf(publ, "%s\n", subject);
	fdumphex(uidBuf, uid_len, publ);
	fprintf(publ," ;\n");
	if ((tempbuf = (char *)EncodePublic(keys))==NULL) {
                printf("\n%s: Allocation Error.\n", __FILE__);
                return(0);
        }
	fdumphex(tempbuf, DecodeTotalLength(tempbuf), publ);
	FreePublic(tempbuf);
	fprintf(publ," ;\n");
        fclose(publ);
}
